# buildforkernels macro hint: when you build a new version or a new release
# that contains bugfixes or other improvements then you must disable the
# "buildforkernels newest" macro for just that build; immediately after
# queuing that build enable the macro again for subsequent builds; that way
# a new akmod package will only get build when a new one is actually needed
%define buildforkernels newest

Name:		compcache
Version:	0.7
Release:	1%{?dist}
Summary:	Kernel module for compress ram ramzswap devices
Group:		System Environment/Kernel
License:	GPL
URL:		http://code.google.com/p/compcache/
Source0:	compcache-0.7.tgz
Source1:	zram.modules
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	%{_bindir}/kmodtool
Requires:	kmod-compcache
# needed for plague to make sure it builds for i586 and i686
ExclusiveArch:  i686 x86_64
# ppc disabled because fedora no longer supports it

%{!?kernels:BuildRequires: buildsys-build-rpmfusion-kerneldevpkgs-%{?buildforkernels:%{buildforkernels}}%{!?buildforkernels:current}-%{_target_cpu} }

# kmodtool does its magic here
%{expand:%(kmodtool --target %{_target_cpu} --repo rpmfusion --kmodname %{name}  %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null) }

%description
This project creates RAM based block device (named ramzswap) which acts as swap disk. Pages swapped to this disk are compressed and stored in memory itself.

%prep
# error out if there was something wrong with kmodtool
%{?kmodtool_check}

# print kmodtool output for debugging purposes:
kmodtool --target %{_target_cpu}  --repo rpmfusion --kmodname %{name} %{?buildforkernels:--%{buildforkernels}} %{?kernels:--for-kernels "%{?kernels}"} 2>/dev/null

%setup -q -c -T
mkdir %{name}-%{version}-src
pushd %{name}-%{version}-src
tar xzf %{SOURCE0}
popd

for kernel_version in %{?kernel_versions} ; do
 cp -a %{name}-%{version}-src _kmod_build_${kernel_version%%___*}
done

%build
for kernel_version in %{?kernel_versions}; do
 pushd _kmod_build_${kernel_version%%___*}
 make -C ${kernel_version##*___} M=`pwd`/compcache-0.7/ modules
popd
done

%install
rm -rf ${RPM_BUILD_ROOT}
for kernel_version in %{?kernel_versions}; do
 pushd _kmod_build_${kernel_version%%___*}
 mkdir -p ${RPM_BUILD_ROOT}%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}
 install -m 644 compcache-0.7/*.ko ${RPM_BUILD_ROOT}%{kmodinstdir_prefix}/${kernel_version%%___*}/%{kmodinstdir_postfix}
# mkdir -p ${RPM_BUILD_ROOT}/usr/bin
# install -m 644 compcache-0.6.2/sub-projects/rzscontrol/rzscontrol ${RPM_BUILD_ROOT}/usr/bin
 install -D %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/modules/zram.modules
 popd
done
chmod 0755 $RPM_BUILD_ROOT/%{kmodinstdir_prefix}/*/%{kmodinstdir_postfix}/* || :
%{?akmod_install}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%{_sysconfdir}/sysconfig/modules/zram.modules

%post
echo "modprobe lzo_compress; modprobe zram" > $RPM_BUILD_ROOT/%{_sysconfdir}/modules/zram.modules
chmod 0644 $RPM_BUILD_ROOT/%{_sysconfdir}/modules/zram.modules

%changelog
* Fri Aug 6 2010 Dave RIches <dcr226@fedorapeople.org> 0.6.2-1
- Initial build.
